/*
 * Copyright (c) 1998-2000 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * The contents of this file constitute Original Code as defined in and
 * are subject to the Apple Public Source License Version 1.1 (the
 * "License").  You may not use this file except in compliance with the
 * License.  Please obtain a copy of the License at
 * http://www.apple.com/publicsource and read it before using this file.
 * 
 * This Original Code and all software distributed under the License are
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
/*
 * Copyright (c) 1998 Apple Computer, Inc.  All rights reserved.
 *
 * HISTORY
 *
 */


#ifndef _IOKIT_IOUSBLOG_H
#define _IOKIT_IOUSBLOG_H

#include <IOKit/IOService.h>
#include <IOKit/usb/USB.h>
#include <IOKit/usb/IOUSBDevice.h>

#define kMaxStatusBufSize	(8*1024)

class IOUSBLog : public IOService
{
    OSDeclareAbstractStructors(IOUSBLog)
    
private:
    char		_gStatusBuffer[kMaxStatusBufSize];
    UInt32		_gStatusBufSize;
    UInt32		_gStatusUpdate;
    UInt8		_gStatusLevel;
    bool		_gdoIOLog;
    bool		_gdokprintf;

public:
    bool		init( OSDictionary * dictionary = 0 );
    static IOUSBLog	*usblog();


    void 	AddStatusLevel (UInt32 level, UInt32 ref, char *status, UInt32 value);
    void	AddStatus(char *message);

};

#endif /* ! _IOKIT_IOUSBLOG_H */

