#ifndef	_semaphore_user_
#define	_semaphore_user_

/* Module semaphore */

#include <string.h>
#include <mach/ndr.h>
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/port.h>

#ifdef AUTOTEST
#ifndef FUNCTION_PTR_T
#define FUNCTION_PTR_T
typedef void (*function_ptr_t)(mach_port_t, char *, mach_msg_type_number_t);
typedef struct {
        char            *name;
        function_ptr_t  function;
} function_table_entry;
typedef function_table_entry 	*function_table_t;
#endif /* FUNCTION_PTR_T */
#endif /* AUTOTEST */

#ifndef	semaphore_MSG_COUNT
#define	semaphore_MSG_COUNT	7
#endif	/* semaphore_MSG_COUNT */

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <mach/mach_types.h>

#ifdef __BeforeMigUserHeader
__BeforeMigUserHeader
#endif /* __BeforeMigUserHeader */


/* Routine semaphore_signal */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_signal
(
	semaphore_t semaphore
);

/* Routine semaphore_signal_all */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_signal_all
(
	semaphore_t semaphore
);

/* Routine semaphore_wait */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_wait
(
	semaphore_t semaphore
);

/* Routine semaphore_signal_thread */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_signal_thread
(
	semaphore_t semaphore,
	thread_act_t thread
);

/* Routine semaphore_timedwait */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_timedwait
(
	semaphore_t semaphore,
	mach_timespec_t wait_time
);

/* Routine semaphore_wait_signal */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_wait_signal
(
	semaphore_t wait_semaphore,
	semaphore_t signal_semaphore
);

/* Routine semaphore_timedwait_signal */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t semaphore_timedwait_signal
(
	semaphore_t wait_semaphore,
	semaphore_t signal_semaphore,
	mach_timespec_t wait_time
);

#ifndef subsystem_to_name_map_semaphore
#define subsystem_to_name_map_semaphore \
    { "semaphore_signal", 617200 },\
    { "semaphore_signal_all", 617201 },\
    { "semaphore_wait", 617202 },\
    { "semaphore_signal_thread", 617203 },\
    { "semaphore_timedwait", 617204 },\
    { "semaphore_wait_signal", 617205 },\
    { "semaphore_timedwait_signal", 617206 }
#endif

#ifdef __AfterMigUserHeader
__AfterMigUserHeader
#endif /* __AfterMigUserHeader */

#endif	 /* _semaphore_user_ */
