/*
 * Copyright (c) 2000 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * The contents of this file constitute Original Code as defined in and
 * are subject to the Apple Public Source License Version 1.1 (the
 * "License").  You may not use this file except in compliance with the
 * License.  Please obtain a copy of the License at
 * http://www.apple.com/publicsource and read it before using this file.
 * 
 * This Original Code and all software distributed under the License are
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */

#ifndef _FSPROPERTIES_H_
#define _FSPROPERTIES_H_

/* Info plist keys */
#define kFSMediaTypes             "FSMediaTypes"
#define kFSPersonalities          "FSPersonalities"

/* Sub-keys for kFSMediaTypes dictionaries */
#define kFSMediaProperties        "FSMediaProperties"
#define kFSProbeArguments         "FSProbeArguments"
#define kFSProbeExecutable        "FSProbeExecutable"
#define kFSProbeOrder             "FSProbeOrder"

/* Sub-keys for kFSPersonalities dictionaries */
#define kFSFormatArguments        "FSFormatArguments"
#define kFSFormatContentMask      "FSFormatContentMask"
#define kFSFormatExecutable       "FSFormatExecutable"
#define kFSFormatMinimumSize      "FSFormatMinimumSize"
#define kFSMountArguments         "FSMountArguments"
#define kFSMountExecutable        "FSMountExecutable"
#define kFSName                   "FSName"
#define kFSRepairArguments        "FSRepairArguments"
#define kFSRepairExecutable       "FSRepairExecutable"
#define kFSVerificationArguments  "FSVerificationArguments"
#define kFSVerificationExecutable "FSVerificationExecutable"

#endif /* _FSPROPERTIES_H_ */
